import string
import gtk
import gobject
import os
import functions
import time

##
## I18N
## 
import gettext
gettext.bindtextdomain ("firstboot", "/usr/share/locale")
gettext.textdomain ("firstboot")
_=gettext.gettext

class childWindow:
    #You must specify a runPriority for the order in which you wish your module to run
    runPriority = 130
    moduleName = (_("Red Hat Network"))
                
    def launch(self, doDebug=None):
        if doDebug:
            print "launching up2date module"
        else:
            if os.access('/etc/sysconfig/rhn/systemid', os.F_OK):
                return None, None, None

        self.vbox = gtk.VBox()
        self.vbox.set_size_request(400, 200)

        title_pix = functions.imageFromFile("up2date.png")

        internalVBox = gtk.VBox()
        internalVBox.set_border_width(10)

        label = gtk.Label(_("This step will register your system with a complimentary Demo Account from "
                            "Red Hat Network so that you can receive the latest software "
                            "packages directly from Red Hat.  Using this tool will allow you "
                            "to always have the most up-to-date Red Hat Linux system "
                            "with all the security patches, bug fixes, and software "
                            "enhancements. \n\n"
                            "If you purchased this product, you are entitled to a free trial of Red "
                            "Hat Network Basic Service. To access the free trial, please refer to the "
                            "product activation card found in the box for detailed instructions. \n\n"
                            "If you did not purchase this product, visit http://rhn.redhat.com for "
                            "more information or to subscribe to Red Hat Network Basic Service. \n"))

        label.set_line_wrap(gtk.TRUE)
        label.set_size_request(500, -1)
        label.set_alignment(0.0, 0.5)
        internalVBox.pack_start(label, gtk.FALSE, gtk.TRUE)

        radioBox = gtk.VBox()

        self.radioYes = gtk.RadioButton(None, _("_Yes, I want to register my system with Red Hat Network."))
        radioNo = gtk.RadioButton(self.radioYes, _("_No, I do not want to register my system."))

        radioBox.pack_start(self.radioYes, gtk.FALSE)
        radioBox.pack_start(radioNo, gtk.FALSE)

        if doDebug:
            radioNo.set_active(gtk.TRUE)

        a = gtk.Alignment()
        a.add(radioBox)
        a.set(0.3, 0.0, 0.3, 0.5)
        internalVBox.pack_start(a, gtk.FALSE, padding=10)

        self.vbox.pack_start(internalVBox, gtk.TRUE)

        return self.vbox, title_pix, self.moduleName

    def run_up2date(self, *args):
        #Create a gtkInvisible dialog to block until up2date is complete
        i = gtk.Invisible ()
        i.grab_add ()

        #Run rhn_register so they can register with RHN
        pid = functions.start_process("/usr/bin/up2date")

        flag = None
        while not flag:
            while gtk.events_pending():
                gtk.main_iteration_do()

            child_pid, status = os.waitpid(pid, os.WNOHANG)
            
            if child_pid == pid:
                flag = 1
            else:
                time.sleep(0.1)

        i.grab_remove ()

    def apply(self, notebook):
        # If they want to register, then kick off rhn_register.  If not, then pass
        if self.radioYes.get_active() == gtk.TRUE:            
            #We can ping www.redhat.com, so the network is active
            self.run_up2date()
        return 0
            
